subroutine bernsteinSiC
  use variables
  implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)

!c     .. Scalar Arguments ..
  CHARACTER          JOBZ, UPLO
  INTEGER            INFO, ITYPE, LDA, LDB, LWORK, N
  nm=mm

  if (initialize_bsSiC) then
     call setparam_bsSiC
     initialize_bsSiC = .false.
  endif

!c-----Bookkeeping----------------------------------------------------------
  call registration2
  
!c-------------------------------------------------------------------

!c-----Reset energy and force--------------------------------------------
  eb=0.0d0
  do i=1,na
     fhx(i)=0.0d0
     fhy(i)=0.0d0
     fhz(i)=0.0d0
  enddo

  do ks=1,ns

!c-----Calculation of Hamiltonian---------------------------------------
     call const_hs_bsSiC(ks)
!c------------------------------------------------------------------
      
     do i=1,nm
        do j=1,nm
           cbb(i,j)=cmplx(sr(i,j),si(i,j))
           caa(i,j)=cmplx(ar(i,j),ai(i,j))
           if(ks.eq.1) write(89,*) caa(i,j)
        enddo
     enddo
     
!c-----Solve eigenvalue problem
     noc=2*na
     itype=1
     uplo='u'
     jobz='V'
     lwork=(nm+1)*nm

     call ZHEGV( ITYPE, JOBZ, UPLO, Nm, caA, nm, cbB, nm, &
          W, WORK,LWORK, RWORK, INFO )
!c        print *, "ok2"
     if(info.ne.0) print *, "ERROR in papatb4",Nm,info

!c      if (ks.eq.1) eganma=w(noc/2)
     do i=1,nm
        ew(i)=w(i)*13.6d0
     enddo


     do i=1,nm
        eivtot=0.0d0
        do j=1,nm
           eivtot=eivtot+abs(caa(j,i))**2
        enddo
        eivc=abs(caa(1,i))**2/eivtot+abs(caa(2,i))**2/eivtot+ &
             abs(caa(3,i))**2/eivtot+abs(caa(4,i))**2/eivtot
        evalue(i,ks)=w(i)*13.6d0
        weight(i,ks)=eivc
     enddo

!c      print *, eb
!c-----calculation of energy and force

     call calc_ef_bsSiC(ks)
  end do

      
!     unit: Newton
  do i=1,na
     fx(i)=fhx(i)*13.6d0*1.60219d-9/0.529177d0
     fy(i)=fhy(i)*13.6d0*1.60219d-9/0.529177d0
     fz(i)=fhz(i)*13.6d0*1.60219d-9/0.529177d0
  enddo
909 format(1x,"FORCE=",i3,3d16.8)
  et=eb

end subroutine bernsteinSiC

 subroutine setparam_bsSiC
   use variables
   use parambsSiC
   allocate (rho(na,2),drhox2(na,na,2),drhoy2(na,na,2),drhoz2(na,na,2))
   return
 end subroutine setparam_bsSiC
