C  ****************************************************************
C
C       SUBROUTINE CAREPS: CALCULATION OF REPULSIVE ENERGIES
C                          BY WANG METHOD
C  ****************************************************************
      SUBROUTINE CAREPS(NA,RPI,FRX,FRY,FRZ,NN,DX,DY,DZ,para,s
     &                 ,dsx,dsy,dsz,rab,drabx,draby,drabz,parac,MAN,ip
     &                 ,sumphi)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION RPI(NA),FRX(NA),FRY(NA),FRZ(NA),NN(NA)
     &         ,para(7,8),parac(0:4),DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA)
     &         ,s(7,man,na),dsx(7,man,na),dsy(7,man,na),dsz(7,man,na)
     &         ,rab(6,man,na),drabx(6,man,na)
     &         ,draby(6,man,na),drabz(6,man,na)
     &         ,sumphi(na)
     &         ,IP(MAN,NA)

c-----ͥ륮η׻
      DO 100 I=1,NA
      RPI(I)=0.0D0
      sumphi(i)=0.0d0
  100 CONTINUE

      DO 110 I=1,NA
         MM=NN(I)
         DO 120 J=1,MM
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)

            phi0=para(5,1)*rab(5,j,i)**(-para(5,2))
     &         *exp(-para(5,3)*rab(5,j,i)**(para(5,4)))
     &                    *(1.0d0-s(5,j,i))

            sumphi(i)=sumphi(i)+phi0

 120     CONTINUE
         RPI(I)=parac(0)
     &         +parac(1)*sumphi(i)
     &         +parac(2)*(sumphi(i)**2.0d0)
     &         +parac(3)*(sumphi(i)**3.0d0)
     &         +parac(4)*(sumphi(i)**4.0d0)
 110  CONTINUE

c-----Ϥη׻
      DO 101 I=1,NA
      FRX(i)=0.0D0
      FRY(i)=0.0D0
      FRZ(i)=0.0D0
  101 CONTINUE

      DO 111 I=1,NA
         MM=NN(I)
         DO 121 J=1,MM
            K=IP(J,I)
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)

            phi0=para(5,1)*rab(5,j,i)**(-para(5,2))
     &         *exp(-para(5,3)*rab(5,j,i)**(para(5,4)))
     &                    *(1.0d0-s(5,j,i))

            dphix=(-para(5,2)*drabx(5,j,i)/rab(5,j,i)
     &             -para(5,3)*para(5,4)
     &              *rab(5,j,i)**(para(5,4)-1.0d0)*drabx(5,j,i)
     &             -dsx(5,j,i)/(1.0d0-s(5,j,i)))*phi0
            dphiy=(-para(5,2)*draby(5,j,i)/rab(5,j,i)
     &             -para(5,3)*para(5,4)
     &              *rab(5,j,i)**(para(5,4)-1.0d0)*draby(5,j,i)
     &             -dsy(5,j,i)/(1.0d0-s(5,j,i)))*phi0
            dphiz=(-para(5,2)*drabz(5,j,i)/rab(5,j,i)
     &             -para(5,3)*para(5,4)
     &              *rab(5,j,i)**(para(5,4)-1.0d0)*drabz(5,j,i)
     &             -dsz(5,j,i)/(1.0d0-s(5,j,i)))*phi0
c         print *,i,k,dphix,dphiy,dphiz

C         FF=parac(1)+2.0d0*parac(2)*sumphi(i)
C     &      +3.0d0*parac(3)*sumphi(i)**2+4.0d0*parac(4)*sumphi(i)**3
C         FRX(i)=FRX(i)-FF*dphix
C         FRY(i)=FRY(i)-FF*dphiy
C         FRZ(i)=FRZ(i)-FF*dphiz
C         FRX(k)=FRX(k)+FF*dphix
C         FRY(k)=FRY(k)+FF*dphiy
C         FRZ(k)=FRZ(k)+FF*dphiz

         FD1=parac(1)+2.0d0*parac(2)*sumphi(i)
     &      +3.0d0*parac(3)*sumphi(i)**2+4.0d0*parac(4)*sumphi(i)**3
         FD2=parac(1)+2.0d0*parac(2)*sumphi(k)
     &      +3.0d0*parac(3)*sumphi(k)**2+4.0d0*parac(4)*sumphi(k)**3
         FF=FD1+FD2
         FRX(i)=FRX(i)-FF*dphix
         FRY(i)=FRY(i)-FF*dphiy
         FRZ(i)=FRZ(i)-FF*dphiz

C         print *,'rpi(',i,')=',rpi(i)
C         print *,i,j,k,dphix,dphiy,dphiz,ff
C         print *,i,j,k,FRX(i),FRy(i),FRz(i)
 121     CONTINUE
 111  CONTINUE

C      do i=1,na
C      print *,frx(i),fry(i),frz(i)
C      enddo


      RETURN
      END
