C  ******************************************************************
C
C       SUBROUTINE casr: CALCULATION OF Sab AND Rab and dS and dR
C
C  *******************************************************************
      SUBROUTINE casr(NA,nn,ip,dx,dy,dz,X,Y,Z,jp1,jp2,jp3,MM1,MM2,MM3
     &               ,a1,a2,a3,para,g0,s,dsx,dsy,dsz
     &               ,rab,drabx,draby,drabz,man,rs
     &               ,dgajx,dgajy,dgajz)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION NN(NA),ga(na),dgax(na),dgay(na),dgaz(na)
     &         ,IP(MAN,NA),DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA)
     &         ,xi(7,man,na),sumdsx(7),sumdsy(7),sumdsz(7)
     &         ,X(NA),Y(NA),Z(NA),JP1(MAN,NA),JP2(MAN,NA),JP3(MAN,NA)
     &         ,a1(3),a2(3),a3(3)
     &         ,para(7,8)
     &         ,s(7,man,na),dsx(7,man,na),dsy(7,man,na),dsz(7,man,na)
     &         ,rab(6,man,na),drabx(6,man,na)
     &         ,draby(6,man,na),drabz(6,man,na)
     &         ,dgajx(man,na),dgajy(man,na),dgajz(man,na)

C
C      Sab CALCULATION
C
c       print *,para(7,5),para(7,6),para(7,7)
       do 20 i=1,na
        ga(i)=0.0d0
        dgax(i)=0.0d0
        dgay(i)=0.0d0
        dgaz(i)=0.0d0
 20    continue

       do m=1,na
       do l=1,man
       do k=1,7
         xi(k,l,m)=0.0d0
       enddo
       enddo
       enddo


      DO 100 I=1,NA
       MM=NN(I)
       DO 110 J=1,MM
        IK=IP(J,I)

        RX=DX(J,I)
        RY=DY(J,I)
        RZ=DZ(J,I)
        R2=RX**2+RY**2+RZ**2
        RR=DSQRT(R2)
        RLL=RX/RR
        RMM=RY/RR
        RNN=RZ/RR

        j1=jp1(j,i)
        j2=jp2(j,i)
        j3=jp3(j,i)


        do 40 k=1,7
         sumdsx(k)=0.0d0
         sumdsy(k)=0.0d0
         sumdsz(k)=0.0d0
 40     continue

        mmjk=nn(ik)
        do 120 k=1,mmjk
         ikk=ip(k,ik)
         k1=jp1(k,ik)+j1
         k2=jp2(k,ik)+j2
         k3=jp3(k,ik)+j3

         if ((ikk.eq.i).and.(k1.eq.0).and.(k2.eq.0).and.(k3.eq.0))
     &    go to 120

         xik=X(ikk)+a1(1)*k1+a2(1)*k2+a3(1)*k3-X(I)
         yik=Y(ikk)+a1(2)*k1+a2(2)*k2+a3(2)*k3-Y(I)
         zik=Z(ikk)+a1(3)*k1+a2(3)*k2+a3(3)*k3-Z(I)
         rik=DSQRT(xik**2+yik**2+zik**2)

         xjk=DX(k,ik)
         yjk=DY(k,ik)
         zjk=DZ(k,ik)
         rjk=DSQRT(xjk**2+yjk**2+zjk**2)

         IF(Rik.LT.0.000001D0) GO TO 120
         IF(Rik.GT.RS) GO TO 120

         IF(Rjk.LT.0.000001D0) GO TO 120
         IF(Rjk.GT.RS) GO TO 120

         rikll=xik/rik
         rikmm=yik/rik
         riknn=zik/rik

          do 30 kk=1,7
           temp1=para(kk,5)*exp(-para(kk,6)
     &                      *((rik+rjk)/rr)**para(kk,7))
           xi(kk,j,i)=xi(kk,j,i)+temp1

           temp2=-para(kk,6)*para(kk,7)
     &          *((rik+rjk)/rr)**(para(kk,7)-1.0d0)

           sumdsx(kk)=sumdsx(kk)+temp1*temp2
     &               *((rik+rjk)/(rr**2)*rll-rikll/rr)

           sumdsy(kk)=sumdsy(kk)+temp1*temp2
     &               *((rik+rjk)/(rr**2)*rmm-rikmm/rr)

           sumdsz(kk)=sumdsz(kk)+temp1*temp2
     &               *((rik+rjk)/(rr**2)*rnn-riknn/rr)
 30       continue
 120    CONTINUE

        do 160 k=1,7
         s(k,j,i)=dtanh(xi(k,j,i))
         dsx(k,j,i)=1.0d0/(dcosh(xi(k,j,i))**(2))*sumdsx(k)
         dsy(k,j,i)=1.0d0/(dcosh(xi(k,j,i))**(2))*sumdsy(k)
         dsz(k,j,i)=1.0d0/(dcosh(xi(k,j,i))**(2))*sumdsz(k)
 160    continue
 110   continue
 100  continue

      do i=1,na
       MM=NN(I)
      do j=1,mm
        ga(i)=ga(i)+1.0d0-s(7,j,i)
        dgax(i)=dgax(i)-dsx(7,j,i)
        dgay(i)=dgay(i)-dsy(7,j,i)
        dgaz(i)=dgaz(i)-dsz(7,j,i)
      enddo
c      print '(1x,d16.8)', ga(i)


      enddo

      do i=1,na
       MM=NN(I)
       DO J=1,MM
        dgajx(j,i)=0.0d0
        dgajy(j,i)=0.0d0
        dgajz(j,i)=0.0d0
       enddo
      enddo

      DO 101 i=1,NA
       MM=NN(i)
       DO 111 j=1,MM
        IK=IP(j,i)
        RX=DX(j,i)
        RY=DY(j,i)
        RZ=DZ(j,i)
        R2=RX**2+RY**2+RZ**2
        RR=DSQRT(R2)
        RLL=RX/RR
        RMM=RY/RR
        RNN=RZ/RR
        j1=jp1(j,i)
        j2=jp2(j,i)
        j3=jp3(j,i)
        dgajx(j,i)=dgajx(j,i)-dsx(7,j,i)
        dgajy(j,i)=dgajy(j,i)-dsy(7,j,i)
        dgajz(j,i)=dgajz(j,i)-dsz(7,j,i)

        mmjk=nn(ik)
        do 121 k=1,mmjk
         ikk=ip(k,ik)
         k1=jp1(k,ik)+j1
         k2=jp2(k,ik)+j2
         k3=jp3(k,ik)+j3

         if ((ikk.eq.i).and.(k1.eq.0).and.(k2.eq.0).and.(k3.eq.0))
     &    go to 121

          xik=X(ikk)+a1(1)*k1+a2(1)*k2+a3(1)*k3-X(I)
          yik=Y(ikk)+a1(2)*k1+a2(2)*k2+a3(2)*k3-Y(I)
          zik=Z(ikk)+a1(3)*k1+a2(3)*k2+a3(3)*k3-Z(I)
          rik=DSQRT(xik**2+yik**2+zik**2)

         IF(Rik.LT.0.000001D0) GO TO 121
         IF(Rik.GT.RS) GO TO 121

         rikll=xik/rik
         rikmm=yik/rik
         riknn=zik/rik

          xjk=DX(k,ik)
          yjk=DY(k,ik)
          zjk=DZ(k,ik)
          rjk=DSQRT(xjk**2+yjk**2+zjk**2)

         IF(Rjk.LT.0.000001D0) GO TO 121
         IF(Rjk.GT.RS) GO TO 121


          dgajtemp=para(7,5)*exp(-para(7,6)*((rr+rik)/rjk)**para(7,7))
     &       *(-para(7,6)*para(7,7)*((rr+rik)/rjk)**(para(7,7)-1.0d0))

          dgajx(j,i)=dgajx(j,i)-dgajtemp
     &                    *(-RLL-rikll)/rjk
     &                    *((dcosh(xi(7,k,ik)))**(-2))

          dgajy(j,i)=dgajy(j,i)-dgajtemp
     &                    *(-RMM-rikmm)/rjk
     &                    *((dcosh(xi(7,k,ik)))**(-2))

          dgajz(j,i)=dgajz(j,i)-dgajtemp
     &                    *(-RNN-riknn)/rjk
     &                    *((dcosh(xi(7,k,ik)))**(-2))
  121    continue
  111   continue
  101  continue


c-------------------------------------------------------------------------------
C     Rab CALCULATION
c-------------------------------------------------------------------------------

      do 300 i=1,na
       mm=nn(i)
       do 310 j=1,mm
        ik=ip(j,i)
        RX=DX(J,I)
        RY=DY(J,I)
        RZ=DZ(J,I)
        R2=RX**2+RY**2+RZ**2
        RR=DSQRT(R2)

        RLL=RX/RR
        RMM=RY/RR
        RNN=RZ/RR

        do 50 k=1,6
         rab(k,j,i)=rr*(1.0d0+para(k,8)/2.0d0
     &          *((ga(i)-g0)/g0+(ga(ik)-g0)/g0))

         drabx(k,j,i)=-RLL*(1.0d0+para(k,8)/2.0d0
     &                    *((ga(i)-g0)/g0+(ga(ik)-g0)/g0))
     &                +rr*(para(k,8)/2.0d0/g0*(dgax(i)+dgajx(j,i)))

         draby(k,j,i)=-RMM*(1.0d0+para(k,8)/2.0d0
     &                    *((ga(i)-g0)/g0+(ga(ik)-g0)/g0))
     &                +rr*(para(k,8)/2.0d0/g0*(dgay(i)+dgajy(j,i)))

         drabz(k,j,i)=-RNN*(1.0d0+para(k,8)/2.0d0
     &                    *((ga(i)-g0)/g0+(ga(ik)-g0)/g0))
     &                +rr*(para(k,8)/2.0d0/g0*(dgaz(i)+dgajz(j,i)))
 50     continue
 310   continue
 300  continue
      RETURN
      END
