!---Initial velocity set
subroutine initial_velocity(n,vx,vy,vz,wm,temp_set,ran_seed)
  implicit double precision (a-h,o-z)
  double precision :: vx(n),vy(n),vz(n)
  double precision :: px(n),py(n),pz(n)
  integer*4 :: timeArray(3)
  integer :: ran_seed
  double precision, parameter :: bl = 1.380662d-23

  if (ran_seed<0) then
!         ii=8293
     call itime(timeArray)
     ii=ii + timeArray(1) + timeArray(2) + timeArray(3)
  else
     ii=ran_seed
  endif
  do i=1,n
     x=0.0d0
     y=0.0d0
     z=0.0d0
     do k=1,12
        ra=random(ii)
        x=x+ra
     enddo
     do k=1,12
        ra=random(ii)
        y=y+ra
     enddo
     do k=1,12
        ra=random(ii)
        z=z+ra
     enddo
     vx(i)=sqrt(bl*temp_set/wm)*(x-6.0d0)/0.529177d-10
     vy(i)=sqrt(bl*temp_set/wm)*(y-6.0d0)/0.529177d-10
     vz(i)=sqrt(bl*temp_set/wm)*(z-6.0d0)/0.529177d-10
  enddo
  !      do i=1,n
  !         if (mfx(i)=='F') then;vx(i)=0.0d0;endif
  !         if (mfy(i)=='F') then;vy(i)=0.0d0;endif
  !         if (mfz(i)=='F') then;vz(i)=0.0d0;endif
  !      enddo

!-----運動量の計算
      do 120 k=1,n
         px(k)=vx(k)*wm
         py(k)=vy(k)*wm
         pz(k)=vz(k)*wm
 120  continue

!-----運動エネルギーの計算
      enkin=0.0d0
      do 105 k=1,n
         enkin=enkin+(px(k)**2+py(k)**2+pz(k)**2)/wm/2.0d0
 105  continue
      ary=0.529177d0*0.529177d0
      temp=2*enkin/3/n/(1.38054d-23)*1.0d-20*ary
      print *,'Initial Temp = ', temp

end subroutine initial_velocity
!---random function---
double precision function random(m)
  m=48828215*m
  if (m.lt.0) m=(m+2147483647)+1
  random=dble(m)/dble(2147483647)
end function random
