!  
! Tight-Binding MD code
! tentatively for carbon with the Papaconstantpoulos potential
! March 2012- Modified for SiC (parameter by Berstein et al (PRB71 075203 2005))
!

program main
  use variables
  IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)

  dimension aa1(3),aa2(3),aa3(3)
  character num(0:9)

!  na=32
  ns=20; man=300; ksc=30; nds=1000

!c-----TIME STEP----------------------------------------------
  dt=1.0d-15
!c-----MASS OF PROTON & NEUTRON-------------------------------
  am=1.6726485d-27
  bm=1.6749543d-27
!c-----MASS OF THE ATOM---------------------------------------
  wm=am*6.0d0+bm*6.0d0
!     Temperature
  temp=30.0d0
! Number of MD steps
  istep_end = 0
!c-----LATTICE CONSTANT & CUT OFF DISTANCE--------------------
!      ao=1.424d0         !graphite
!      ao=5.43d0          !SILICON
!  do i=1,na
!     fx(i)=0.0d0
!     fy(i)=0.0d0
!     fz(i)=0.0d0
!  enddo
!c      do 3000 ie=-30,30
!c         ao=1.424d0+1.424*0.01d0*ie

!      ao=3.0d0           !diamond
!      rc=3.7d0
!      rc=5.0d0
!      rc=6.0d0
  rc=6.0d0     ! cutoff (angstrom)
!  ao=ao/0.529177d0 ! convert to Bohr
  rc=rc/0.529177d0 ! convert to Bohr
!c      rs=1.5d0
  rr2=rc**2

! file for output
  open(80,file='step-energy.dat')

!c-----ATOM POSITIONS & TRANSLATION VECTORS-------------------
  call readconfig
  mm=4*na

  allocate (xa(na),ya(na),za(na),xs(ns),ys(ns),zs(ns),ak(ns))
  allocate (fx(na),fy(na),fz(na),xo(na),yo(na),zo(na),vx(na),vy(na),vz(na))

  allocate (hdx(4,4,man,na),hdy(4,4,man,na),hdz(4,4,man,na))
  allocate (fhx(na),fhy(na),fhz(na))
  allocate (ar(mm,mm),ai(mm,mm),sr(mm,mm),si(mm,mm),rwork((3*mm-1)*mm))
  allocate (rou(na),es(na),ep(na),sdx(4,4,man,na),sdy(4,4,man,na),sdz(4,4,man,na))
  allocate (desx(na,na),desy(na,na),desz(na,na),depx(na,na),depy(na,na),depz(na,na))
  allocate (w(mm),ew(mm),dos(nds),evalue(mm,ns),weight(mm,ns))
  allocate (caa(mm,mm),cbb(mm,mm),droux2(na,na),drouy2(na,na),drouz2(na,na))
  allocate (work((3*mm-1)*mm))
  allocate (ip(man,na),nn(na),dx(man,na),dy(man,na),dz(man,na))

!c-----SET INITIAL POSITION-----------------------------------
  do i=1,na
     xo(i)=x(i)
     yo(i)=y(i)
     zo(i)=z(i)
  enddo
  vx=0;vy=0;vz=0;fx=0;fy=0;fz=0

!c-----CALCULATION OF K-VECTORS-------------------------------
  call knano

  print *, "CUT-OFF=",rc

!c-----TB CALCULATION-----------------------------------------
  istep=0
!c-----RELAXATION---------------------------------------------
  do istep=0,istep_end
     if(istep.ne.0) then
        call md(dt,wm,tempc,0)
        call atom_damping(0)
        call kinetic(wm)
     endif

     call papatb4
!     call bernsteinSiC

!     WRITE DATA
     ! Configuration
     ifile=111
     call writeconfig(ifile)

     ! Maximum force
     fmax=0.0
     do i=1,na
        xx=fx(i)**2+fy(i)**2+fz(i)**2
        if (xx>fmax) fmax=xx
     enddo
     fmax=sqrt(fmax)/1.602e-9 ! Convert to eV/ang

     ! DOS
     open (ifile,FILE='dos.d')
     do k=1,ns
        do ib=1,mm
           write (ifile,*) k,evalue(ib,k)
        enddo
        write (ifile,*)
     enddo
     close (ifile)

!     energy output
     write(80,'(i8,3(x,e25.15))') istep,et,enkin,et+enkin
     write (6,'("Step",i8)') istep
     write (6,'("Energy (pot/kin/tot)",3f15.8)') et,enkin,et+enkin
     write (6,'("Fmax=",f15.8,x,"eV/ang")') fmax
     write (6,'("Temp=",f15.8)') temp
     write (6,*)
  enddo

  print *, "   "
  print *, "END."

end program main
