subroutine writeconfig(ifile)
  use variables

  if (istep==0) then
!     open (ifile,FILE='config-init.xsf')
     call write_xsf(ifile,'config-init.xsf')
     call write_cfgs(ifile,'config-init.cfg')
  else if (mod(istep,10) == 1) then
     call write_xsf(ifile,'config.xsf')
     call write_cfgs(ifile,'config.cfg')
  else 
     return
  endif
  
!  if ((dump_frequency>0).and.(mod(step,dump_frequency)==0)) then
!     call conv_num_char7(step,stri7)
!     call write_cfgs(20, 'conf-'//stri7//'.cfg')
!  endif

900 format (3(e26.19,1x))
910 format (1x,3(e26.19,1x),a3,1x,3(a2,1x))
915 format (5(e26.19,1x))
920 format (3(e26.19,1x),i10)

end subroutine writeconfig

      subroutine write_xsf(ifile,filename)
      use variables
      character(*) :: filename
      integer :: ifile,atom_number
      double precision :: hart = 4.35982d-18 ! !Hr=4.35982d-18 J
      double precision :: ang  = 1.0d0/0.529177d0
      double precision :: fmul = 1.0d8

      open (ifile,FILE=filename)
      write (ifile,'(1x,a7)') 'CRYSTAL'
      write (ifile,'(1x,a7)') 'PRIMVEC'
      write (ifile,'(3f10.5)') a1(1)/ang,a1(2)/ang,a1(3)/ang
      write (ifile,'(3f10.5)') a2(1)/ang,a2(2)/ang,a2(3)/ang
      write (ifile,'(3f10.5)') a3(1)/ang,a3(2)/ang,a3(3)/ang
      write (ifile,'(1x,a9)') 'PRIMCOORD'
      write (ifile,'(1x,i8,i8)') na,1
      do i=1,na
         write (ifile,'(i3,1x,6f10.5)') 6,x(i)/ang,y(i)/ang,z(i)/ang &
              ,fx(i)*fmul,fy(i)*fmul,fz(i)*fmul
      enddo

      close (ifile)
      end


! Write standard cfg format file
      subroutine write_cfgs(ifile,filename)
      use variables
      character(*) :: filename
      integer :: ifile
      double precision :: ang  = 1.0d0/0.529177d0
      double precision :: scl_lat = 1.0

      open (ifile,FILE=filename)
      write (ifile,'(a22,i10)') 'Number of particles = ',na
      write (ifile,'(a4,f10.5,a9)') 'A = ',scl_lat,' Angstrom'
      write (ifile,'(a10,f10.5)') 'H0(1,1) = ',a1(1)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(1,2) = ',a1(2)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(1,3) = ',a1(3)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(2,1) = ',a2(1)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(2,2) = ',a2(2)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(2,3) = ',a2(3)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(3,1) = ',a3(1)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(3,2) = ',a3(2)/ang/scl_lat
      write (ifile,'(a10,f10.5)') 'H0(3,3) = ',a3(3)/ang/scl_lat

      do i=1,na
         write (ifile,'(f10.3,1x,a2,1x,6f15.8)') 6.0,'C ',x(i)/a1(1),y(i)/a2(2),z(i)/a3(3),0.,0.,0.
      enddo

      close (ifile)

      end

